# Amity Social Cloud Flutter SDK (Beta)

![xB90BVUsQhVUccACDNyNXlWG49q85LBPfQH_ZN4hz802qPg_yYf-V9eJwDVCxyOse6uAaWBVxbvt8pTylC0AqswiGNwHTE0gx6Z3_I4ts1B_dV5R06u3Vth1E00S](https://github.com/AmityCo/amity_social_cloud_sdk_flutter/assets/9884138/06d4d4dd-58ed-4341-b513-d8c35c927a29)

Table of contents
1. Introduction
2. Features
3. Get started with Amity Social Cloud Flutter SDK
4. Installation

### Introduction
Amity is a technology infrastructure provider that builds ready-to-use social features that can be easily added to any app or website, including: Chat, Profile, Forum, Feed, Video Streaming, Stories, and more.

With Amity’s white-label APIs and SDKs, companies can build thriving communities and grow user engagement, without the hassle of deploying and maintaining any server infrastructure.

Let users create engaging content and engage with others through comments and reactions. Users can follow other users or topics and become members of various groups to get a personalized timeline of content. Activity feeds are also a great feature to directly engage with users. You can communicate with your users directly by posting important messages as announcements.

### Features
- Amity Social Cloud SDK for Flutter allows you to:
- Connect users through formation of communities
- Boost user engagement by user-generated posts/comments in communities
- Personalize the feed based on user’s membership to different groups and communities
- Enable comments on posts within your application, seamlessly
- Support multiple messaging formats when posting content
- Manage & moderate communities and users in admin panel
- Filter out content that includes profanity using our auto-block tools
- React to user-generated content with our reaction tools
- Assign roles and permissions on a role-based system.

Visit [amity.co](https://www.amity.co/) for more information about our [Chat SDK](https://www.amity.co/chat), [Social SDK](https://www.amity.co/social) and [Video SDK](https://www.amity.co/video).

![Y-n9VNyvxgOTZynRWu3RV-OaJ3_57Ch3EPBoWPHfFh9zhRCnjU6G9kCvvgcuA28-hBTuYfBWUcEsUeMibVaIQoGXjK4_bQ_-VdmqjlPIlANBHUrjAZcNB91cn0Ae](https://github.com/AmityCo/amity_social_cloud_sdk_flutter/assets/9884138/2a3ffbd1-1173-4d81-85e4-1f9bba40f934)

### Get started with Amity Social Cloud Flutter SDK
Create your [Amity Social Cloud account](https://portal.amity.co/signup). For more information about setting up an account, please view our tutorial: [how to create an Amity Social Cloud account](https://www.amity.co/tutorials/how-to-create-an-amity-social-cloud-account).

### Installation
Add the SDK to your repository by adding  amity_sdk depedency
With Flutter:
` $ flutter pub add amity_sdk`

This will add a line like this to your package's pubspec.yaml (and run an implicit flutter pub get) :
`dependencies:
  amity_sdk: ^0.0.1`

Alternatively, your editor might support flutter pub get. Check the docs for your editor to learn more.

To learn more about Amity Social Cloud Flutter SDK visit our [documentation](https://docs.amity.co/installation-and-authentication/install-flutter-sdk).


